
#include "searchwidget.h"

#include <Plasma/Theme>
#include <Plasma/Dialog>

#include <KUrl>

#include <QDebug>
#include <QSizePolicy>
#include <QNetworkRequest>
#include <QRegExp>

using namespace Plasma;
using namespace IDOSSearchApplet;


SearchWidget::SearchWidget(QGraphicsWidget *parent)
    : QGraphicsWidget(parent)
{
    
  setUpInterface();
  
}


SearchWidget::~SearchWidget()
{
  
}


void SearchWidget::setUpInterface()
{
 
    m_layout = new QGraphicsLinearLayout(Qt::Vertical,this);
    
    m_from_label = new Label(this);
    m_from_label->setText("Odkud:");
    m_layout->addItem(m_from_label);
    
    m_from = new LineEdit(this);
    m_layout->addItem(m_from);
    
    m_to_label = new Label(this);
    m_to_label->setText("Kam:");
    m_layout->addItem(m_to_label);

    m_to = new LineEdit(this);
    m_layout->addItem(m_to);
    
    m_search_button = new PushButton(this);
    m_search_button->setText("Hledat!");
    connect(m_search_button, SIGNAL(clicked()),this,SLOT(onSearch()));
    m_layout->addItem(m_search_button);
    
    
    m_webview = new WebView(this);
    m_webview->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
    m_webview->setPreferredSize(260,200);
    m_layout->addItem(m_webview);
    
    this->setLayout(m_layout);
    this->setMinimumSize(260, 420);

    m_network_manager = new QNetworkAccessManager(this);
    connect(m_network_manager,SIGNAL(finished(QNetworkReply*)),this,SLOT(onDataLoaded(QNetworkReply*)));
}


void SearchWidget::onSearch()
{
   
   QString url = "http://ttwap.chaps.cz/conn.aspx?Odkud="+m_from->text()+"&Kam="+m_to->text()+"&Datum=&Cas=&JR=&OP=&Lang=C&Format=2&cmd=search";

   m_network_manager->get(QNetworkRequest(url));

}

void SearchWidget::onDataLoaded(QNetworkReply* reply)
{
   QString data = reply->readAll();
   data.replace(QRegExp("<!DOCTYPE*>"),"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/2002/REC-xhtml1-20020801/DTD/xhtml1-transitional.dtd\">");
   data.replace("<wml>","<html>");
   data.replace("</wml>","</html>");
   data.replace("<card","<body");
   data.replace("</card>","</body>");
   data.remove(QRegExp("<template>*</template>"));
   m_webview->setHtml(data.toLatin1(),KUrl("http://ttwap.chaps.cz"));

}



#include "searchwidget.moc"
