#ifndef SEARCHWIDGET_HEADER
#define SEARCHWIDGET_HEADER


#include <QObject>
#include <QWidget>
#include <QGraphicsLinearLayout>
#include <QtNetwork/QNetworkAccessManager>
#include <QtNetwork/QNetworkReply>

#include <KIcon>

#include <Plasma/Applet>
#include <Plasma/LineEdit>
#include <Plasma/Label>
#include <Plasma/PushButton>
#include <Plasma/WebView>


class IDOSSearch;

namespace Plasma
{
  
  class Icon;
  class Dialog;
  
}

namespace IDOSSearchApplet
{
  
  class SearchWidget : public QGraphicsWidget
  {
    Q_OBJECT
    public:
      SearchWidget(QGraphicsWidget *parent = 0);

      ~SearchWidget();
      
    private:
      
      void setUpInterface();
       
      KIcon m_icon;
  
      QGraphicsLinearLayout *m_layout;
      QNetworkAccessManager *m_network_manager;
      
      Plasma::LineEdit *m_from;
      Plasma::LineEdit *m_to;
      Plasma::Label *m_from_label;
      Plasma::Label *m_to_label;
      Plasma::PushButton *m_search_button;
      Plasma::WebView *m_webview;	

    private slots:
      void onSearch();
      void onDataLoaded(QNetworkReply *reply);
  };
}

#endif
